package Voyager.db.clients;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.Frame;
import Voyager.util.*;
import java.net.*;

public class SDBApp
{
  public static void main( String args[ ] )
  {
    boolean useJMF_ = false;
    Frame frame;
    String usage = "usage: SDBApp -u <db url> -d <demo flag> -r <rat flag> -k <keep media clients flag> -i <IOR string> -j <JMF flag> -s <server address>";
    VoyagerSDB sdb = new VoyagerSDB( );
    VoyContext context_ = new VoyAppContext();

    for( int i=0  ;  i < args.length   ;  i++ )
      {
	if( i+1 < args.length )
	  {
	    if( args[ i ].startsWith( "-u" ) ) {
		//context_.showStatus( args[++i] );
	      try {
		context_.retrieveIOR(new java.net.URL(args[++i]));
	      } catch (java.net.MalformedURLException e) {
		  context_.showStatus( "SDBApp: bad -u" + e );
	      }
	      } else if( args[ i ].startsWith( "-i" ) ) {
	      context_.setIOR(args[ ++i ]);
	      } else if( args[ i ].startsWith( "-d" ) )
	      {
		  int demoFlag = 0;
		  if( args[ ++i ].startsWith( "1") )
		      demoFlag = 1;
		sdb.setDemo( demoFlag );
	      } else if( args[ i ].startsWith( "-r" ) )
		  context_.setRatFlag( (args[ ++i ].startsWith( "1" ) ) ? true : false );
	      else if( args[ i ].startsWith( "-k" ) )
		  context_.setKeepMediaFlag( (args[ ++i ].startsWith( "1" ) ) ? true : false );
	      else if( args[ i ].startsWith( "-s" ) )
	      {
		  String server = new String( (args[ ++i ]).trim( ) );
		  try {
		      InetAddress inetaddr = InetAddress.getByName( server );
		      context_.serverHost( server );
		  } catch( UnknownHostException e ) {
		      context_.showStatus( "SDBApp:  bad server name '" +
					   server + "' exception " + e );
		      context_.shutdown( );
		  }
	      }
	  }
      }

    sdb.init( context_ );

    frame = new Frame( "Voyager Multimedia Server" );
    frame.add( "Center" , sdb );
    frame.setSize( 400 , 400 );
    frame.setVisible( true );
  }
}
