package Voyager.db.servers;

import org.omg.CORBA.*;
import java.io.*;
import Voyager.db.*;

public class jServer
{
    public static void main(String args[])
    {
	String refPath = new String( );
	String jdbcurl = new String( );
	String jdbcdriver = new String( );
	String rtsphost = new String( );
	String rtspport = new String( );

	String refFile = new String( );
	String rtspurl = new String( );

	for( int i=0 ; i<args.length ; i++ )
	{
	    if( i+1 < args.length )
	    {
		if( args[ i ].startsWith( "-r" ) )
		    refPath = args[ ++i ];
		else if( args[ i ].startsWith( "-j" ) )
		    jdbcurl = args[ ++i ];
		else if( args[ i ].startsWith( "-d" ) )
		    jdbcdriver = args[ ++i ];
		else if( args[ i ].startsWith( "-e" ) )
		    rtsphost = args[ ++i ];
		else if( args[ i ].startsWith( "-p" ) )
		    rtspport = args[ ++i ];
	    }
	}

	if( refPath.length()==0 || jdbcurl.length()==0 || 
	    jdbcdriver.length()==0 || rtsphost.length()==0 || rtspport.length()==0 )
	{
	    System.err.println( "usage: jServer -r <web directory to write the corba ref file>  -j <jdbc url>  -d <driver spec for the jdbc db>  -e <hostname of the rtspd engine> -p <port on which the rtspd is running>" );
	    System.exit(1);
	}
	else
	{
	    // process argument content
	    //
	    String slashIfNeeded = refPath.endsWith( "/" ) ?
		new String( "" ) : new String( "/" );
	    refFile = refPath + slashIfNeeded + "jVDI.ref";

	    rtspurl = rtsphost + ":" + rtspport;
	}

	try {
	    String noArgs[ ] = new String[ 0 ];
	    //
	    // Create ORB and BOA
	    //
	    ORB orb = ORB.init(noArgs, new java.util.Properties());
	    BOA boa = orb.BOA_init(noArgs, new java.util.Properties());

	    //
	    // Create implementation object
	    //

	    VOY_Database_impl db = new VOY_Database_impl(jdbcurl, jdbcdriver,
							 rtspurl);

	    //
	    // Write out the orb reference in the refFile
	    //
	    try {
		String ref = orb.object_to_string(db);
		FileWriter file = new FileWriter(refFile);
		file.write(ref, 0, ref.length());
		file.close();
		System.out.println( "Wrote " + refFile + ", ready to serve" );
	    } catch(IOException ex) {
		System.err.println("Can't write to `" + ex.getMessage() + "'");
		System.exit(1);
	    }

	    //
	    // Run implementation
	    //
	    boa.impl_is_ready(null);

	    System.exit(0);
	} catch(SystemException ex) {
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }
}
