package Voyager.rtsp;

import java.util.*;

public class Session
{
  public Session()
  {
    id_ = null;
    streams_ = new Vector();
  }
    
  public Session(String id)
  {
    id_ = id;
    streams_ = new Vector();
  }

  public void setName(String d) { name_ = d; }
  public String name() { return name_; }

  public void setDescription(String d) { description_ = d; }
  public String description() { return description_; }

  public String id() { return id_; }
  public void setId(String id) { id_ = id; }

  public static Session parseResponse(Response response)
  {    
    String contentType = (String) response.headers().get("Content-Type");

    if (contentType.equals("x-bob/session-description"))
      {
	BobSDParser parser = new BobSDParser();
	Session session = parser.parseResponse(response);
	return session;
      }

    return null;
  }

  public Enumeration getStreams()
  {
    return streams_.elements();
  }

  public void addStream(String stream)
  {
    streams_.addElement(stream);
  }

  public boolean hasStream(String stream)
  {
    return streams_.contains(stream);
  }
    
  public void removeStream(Stream stream)
  {
    streams_.removeElement(stream);
  }

  public void dump()
  {
    System.out.println("Dumping session " + id_);
    System.out.println("Name: " + name());
    System.out.println("Description: " + description());
    Enumeration e = getStreams();
    String stream;
    while (e.hasMoreElements())
      {
	stream = (String) e.nextElement();
	System.out.println("Stream " + stream);
      }
    System.out.println("Done dumping");
  }

  String id_;
  String name_;
  String description_;

  Vector streams_;
}
