package Voyager.rtsp;

public class TestClient implements Client
{
    public TestClient()
    {
	session_ = new Session("34");
	
	session_.addStream("ssrc1");
	session_.addStream("ssrc2");
    }
    
    public ConnectResult connect(String host, int port)
    {
	System.out.println("Connect to " + host + " / " + port);
	ConnectResult rc = new ConnectResult();
	rc.setSuccess(true);
	return rc;
    }

    public DescribeSessionResult describeSession(String sessionId)
    {
	DescribeSessionResult rc = new DescribeSessionResult();

	if (sessionId.equals(session_.id()))
	{
	    rc.setSuccess(true);
	    rc.setSession(session_);
	}
	else
	{
	    rc.setSuccess(false);
	}
	return rc;
    }

    public DescribeStreamResult describeStream(String sessionId, String stream)
    {
	DescribeStreamResult rc = new DescribeStreamResult();

	if (sessionId.equals(session_.id()))
	{
	    if (session_.hasStream(stream))
	    {
		Stream s = new Stream(stream);

		if (stream.equals("ssrc1"))
		{
		    s.setParameter("start_time", "867897127.845679");
		    s.setParameter("packet_types", "31");
		    s.setParameter("duration", "1798.440709");
		    s.setParameter("file_size", "25495831");
		}
		else
		{
		    s.setParameter("start_time", "867897128.226105");
		    s.setParameter("packet_types", "0");
		    s.setParameter("duration", "1798.468262");
		    s.setParameter("file_size", "5387836");
		}

		rc.setStream(s);
	    }
	    else
	    {
		rc.setSuccess(false);
	    }
	}
	else
	{
	    rc.setSuccess(false);
	}
	return rc;
    }

    public SetupStreamResult setupStream(String sessionId, String stream,
					 String transportInfo,
					 int rtspSession)
    {
	SetupStreamResult rc = new SetupStreamResult();
	
	System.out.println("Setup " + sessionId + " " + stream);

	rc.setHost("voyager1.mcs.anl.gov");
	rc.setPort(10002);

	return rc;
    }

    public PlayStreamResult playStream(String sessionId, String stream)
    {
	System.out.println("Play " + sessionId + " " + stream);
	return new PlayStreamResult();
    }

    public PauseStreamResult pauseStream(String sessionId, String stream)
    {
	System.out.println("Pause " + sessionId + " " + stream);
	return new PauseStreamResult();
    }

    Session session_;
}
