package Voyager.rtsp.clients;

import java.awt.*;
import java.awt.event.*;

public class ControlPanel extends Panel
{
    RecordUI controller_;

    Button recordButton_;
    Button finishButton_;

    public ControlPanel(RecordUI ui)
    {
	super();

	controller_ = ui;
	recordButton_ = new Button( );
	finishButton_ = new Button( );
	
	GridBagLayout layout = new GridBagLayout();
	setLayout(layout);

	GridBagConstraints c = new GridBagConstraints();

	c.gridwidth = GridBagConstraints.RELATIVE;
	c.weightx = 0.0;
	c.fill = GridBagConstraints.NONE;

	Label l = new Label("Recording host: ");
	layout.setConstraints(l, c);
	add(l);

	c.gridwidth = GridBagConstraints.REMAINDER;
	c.weightx = 1.0;
	c.fill = GridBagConstraints.HORIZONTAL;

	l = new Label("alaska");
	layout.setConstraints(l, c);
	add(l);

	//

	c.fill = GridBagConstraints.NONE;

	c.anchor = GridBagConstraints.WEST;

	c.weightx = 1.0;
	c.weighty = 0.0;
	c.gridwidth = GridBagConstraints.REMAINDER;

	Panel p = new Panel();
	p.setLayout(new FlowLayout());

	recordButton_.setLabel("Record");
	p.add(recordButton_);
	
	ActionListener listener = new ActionListener( )
	{
	    public void actionPerformed( ActionEvent e )
	    {
		recordButton_.disable( );
		controller_.controlPanelRecord( );
		finishButton_.enable( );
	    }
	};

	recordButton_.addActionListener(listener);

	Button button = new Button("Pause");
	p.add(button);
	button.setEnabled(false);

	layout.setConstraints(p, c);
	add(p);
	
	c.fill = GridBagConstraints.NONE;

	c.anchor = GridBagConstraints.SOUTHEAST;

	c.weightx = 1.0;
	c.weighty = 1.0;
	c.gridwidth = GridBagConstraints.REMAINDER;

	p = new Panel();
	p.setLayout(new FlowLayout());

	finishButton_.setLabel("Finish");
	p.add(finishButton_);

	listener = new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		controller_.controlPanelDone();
		finishButton_.disable( );
	    }
	};

	finishButton_.addActionListener(listener);

	button = new Button("Help");
	p.add(button);
	button.setEnabled(false);

	layout.setConstraints(p, c);
	add(p);
    }
}
