package Voyager.rtsp.clients;

import java.util.*;
import java.net.*;

public class DestPortData
{
    String videoDest_;
    String audioDest_;
    String vrDest_;

    int videoPort_;
    int audioPort_;
    int vrPort_;

    int ttl_;

    public DestPortData( )
    {
	videoDest_ = new String( );
	audioDest_ = new String( );
	vrDest_ = new String( );

	videoPort_ = 0;
	audioPort_ = 0;
	vrPort_ = 0;

	ttl_ = 16;
    }

    // Accessors
    public void videoDest( String videoDest )
    {
	videoDest_ = videoDest;
    }
    public String videoDest( )
    {
	return videoDest_;
    }
    public void audioDest( String audioDest )
    {
	audioDest_ = audioDest;
    }
    public String audioDest( )
    {
	return audioDest_;
    }
    public void vrDest( String vrDest )
    {
	vrDest_ = vrDest;
    }
    public String vrDest( )
    {
	return vrDest_;
    }
    public void videoPort( int videoPort )
    {
	videoPort_ = videoPort;
    }
    public int videoPort( )
    {
	return videoPort_;
    }
    public void audioPort( int audioPort )
    {
	audioPort_ = audioPort;
    }
    public int audioPort( )
    {
	return audioPort_;
    }
    public void vrPort( int vrPort )
    {
	vrPort_ = vrPort;
    }
    public int vrPort( )
    {
	return vrPort_;
    }
    public void ttl( int ttl )
    {
	ttl_ = ttl;
    }
    public int ttl( )
    {
	return ttl_;
    }


    // Value checkers
    public boolean videoDestOk( String videoDest )
    {
	return destAddrOk( videoDest );
    }
    public boolean audioDestOk( String audioDest )
    {
	return destAddrOk( audioDest );
    }
    public boolean vrDestOk( String vrDest )
    {
	return destAddrOk( vrDest );
    }
    public boolean videoPortOk( int videoPort )
    {
	return true;
    }
    public boolean audioPortOk( int audioPort )
    {
	return true;
    }
    public boolean vrPortOk( int vrPort )
    {
	return true;
    }
    public boolean ttlOk( int ttl )
    {
	return true;
    }
    private boolean destAddrOk( String addr )
    {
	boolean ok = true;

	try {

	    InetAddress inetaddr = InetAddress.getByName( addr );
	} catch( UnknownHostException e ) {
	    ok = false;
	}
	
	return ok;
    }

    public boolean equals( DestPortData dp )
    {
	boolean qEqual = true;

	if( !videoDest_.equals( dp.videoDest( ) ) )
	    qEqual = false;
	else if( !audioDest_.equals( dp.audioDest( ) ) )
	    qEqual = false;
	else if( !vrDest_.equals( dp.vrDest( ) ) )
	    qEqual = false;
	else if( videoPort_ != dp.videoPort( ) )
	    qEqual = false;
	else if( audioPort_ != dp.audioPort( ) )
	    qEqual = false;
	else if( vrPort_ != dp.vrPort( ) )
	    qEqual = false;
	else if( ttl_ != dp.ttl( ) )
	    qEqual = false;

	return qEqual;
    }
}
