package Voyager.rtsp.clients;

import org.omg.CORBA.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import Voyager.util.*;
import Voyager.rtsp.*;
import Voyager.db.*;
import Voyager.db.clients.*;


public class PBApp {

  private final String usage = "usage: PBApp -f <Voyager File>";
  static private org.omg.CORBA.ORB orb;
  static private String vFileName = null;
  static RtspURL url_ = null;

  public static void main(String args[])
  {
    boolean qGoodArgs = false;
    PlaybackManager pm = new PlaybackManager();

    vFileName = new String(args[0]);

    VoyAppContext context = new VoyAppContext();

    orb = context.initCorba();

    String DBURL;
    int sid;
    String IOR = null;

    try {
      BufferedReader br = new BufferedReader(new FileReader(vFileName));
      DBURL = br.readLine();
      sid = Integer.parseInt(br.readLine());

      try {
	URL url = new URL(DBURL);
	IOR = (new BufferedReader(new InputStreamReader(url.openStream()))).readLine();
      } catch (MalformedURLException e) {
	System.out.println("Bad URL format in DBURL parameter: " + DBURL);
      } catch (IOException e) {
	System.out.println("Error reading from URL.");
      }
    
      org.omg.CORBA.Object obj = orb.string_to_object(IOR);
      VOY_Database db = VOY_DatabaseHelper.narrow(obj);

      url_ = new RtspURL(db.getURL(sid));
    } catch (FileNotFoundException e) {
    } catch (IOException e) {
    }

    pm.init( context, url_, new Frame("Voyager Playback") );
  }
}

  
