package Voyager.util;

// This example is from the book _Java in a Nutshell_ by David Flanagan.
// Written by David Flanagan.  Copyright (c) 1996 O'Reilly & Associates.
// You may study, use, modify, and distribute this example for any purpose.
// This example is provided WITHOUT WARRANTY either expressed or implied.


import java.awt.*;
import java.awt.event.*;

public class InfoDialog extends Dialog implements ActionListener, FocusListener {
    protected Button button;
    protected MultiLineLabel label;

    public InfoDialog(Frame parent, String title, String message)
    {
        // Create a dialog with the specified title
        super(parent, title, false);
        
        // Create and use a BorderLayout manager with specified margins
        this.setLayout(new BorderLayout(5,5));

        // Create the message component and add it to the window
        label = new MultiLineLabel(message, 20, 20);
	label.setFont(new Font("Helvetica", java.awt.Font.PLAIN, 14));
        this.add("Center", label);
        
        // Create an Okay button in a Panel; add the Panel to the window
        // Use a FlowLayout to center the button and give it margins.
        button = new Button("Okay");
	label.setFont(new Font("Helvetica", java.awt.Font.PLAIN, 14));
        button.addActionListener(this);
        Panel p = new Panel();
        p.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
        p.add(button);
        this.add("South", p);

        // Resize the window to the preferred size of its components
        this.pack();
    }
    
    // Pop down the window when the button is clicked.
    public void actionPerformed(ActionEvent e)
    {
      if(e.getActionCommand().equals("Okay")) {
            this.invalidate();
            this.dispose();
        }
    }

    // When the window gets the keyboard focus, give it to the button.
    // This allows keyboard shortcuts to pop down the dialog.
    public void focusGained(FocusEvent e) {
        button.requestFocus();
    }
    
    public void focusLost(FocusEvent e) {
    }
}
