#ifndef _Corba_Manager_h
#define _Corba_Manager_h

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if HAVE_LIBOB
#include <OB/CORBA.h>
#else
#error Must define a CORBA type
#endif


class Corba_Manager
{
public:
    Corba_Manager();

    int open(int &argc, char **argv);

    CORBA_Object_ptr objectFromIORFile(VOY_String file);
    CORBA_Object_ptr objectFromWeb(VOY_String host, VOY_String path, int port);

    int objectToIORFile(CORBA_Object_ptr obj, VOY_String file);

    CORBA_ORB_ptr orb() { return orb_; }
    CORBA_BOA_ptr boa() { return boa_; }

private:
    CORBA_ORB_var orb_;
    CORBA_BOA_var boa_;
};

#endif /* _Corba_Manager_h */
