#ifndef _Dispatcher_h
#define _Dispatcher_h

class RTSP_Setup_Request;
class RTSP_Play_Request;
class RTSP_Record_Request;
class RTSP_Describe_Request;
class RTSP_Teardown_Request;

class RTSP_Request_Packet;

class Session_Manager;
class Playback_Manager;
class Record_Manager;

class Dispatcher
{
public:
    Dispatcher(Session_Manager *, Playback_Manager *, Record_Manager *);

    void handleRequestPacket(RTSP_Request_Packet *);

    void handleDescribeRequest(RTSP_Describe_Request *);
    void handlePlaySetupRequest(RTSP_Setup_Request *);
    void handleRecordSetupRequest(RTSP_Setup_Request *);

    void handleTeardownRequest( RTSP_Teardown_Request* );
    void handlePlayRequest(RTSP_Play_Request *);
    void handleRecordRequest(RTSP_Record_Request *);

private:
    Session_Manager *sessionManager_;
    Playback_Manager *playbackManager_;
    Record_Manager *recordManager_;
};

#endif /* _Dispatcher_h */
