#ifndef _Play_Session_Manager_h_
#define _Play_Session_Manager_h_

#include "config.h"
#include "map.h"

/////////////////////////////////////////////////////////////////////////////
//
// Play_Session_Manager.h
//
// Revision History
//     12 Sep 97 - lisa - original version
//

class RTSP_Setup_Request;
class RTSP_Play_Request;
class Play_Stream_Synchronizer;
class Play_Stream_Manager;
class Playback_Network_Transport;
class RTSP_Teardown_Request;

#include "Play_Session_ID.h"
#include "Voyager_Corba.h"

class Play_Session_Manager
{
public:
    Play_Session_Manager(VOY_Database_ptr db, Play_Session_ID id , VOY_String);
    ~Play_Session_Manager(  );

    enum PlaySessionError { kFailure , kSuccess };
    
    PlaySessionError   addStream( RTSP_Setup_Request* ,  Playback_Network_Transport*);
    PlaySessionError   play( RTSP_Play_Request* );

    Play_Session_ID sessionId() { return sessionId_; }

    void teardown( RTSP_Teardown_Request* , short& );

private:

    typedef map< VOY_String , Play_Stream_Manager* , less<VOY_String> > StreamMap;
    
    Play_Session_ID sessionId_;
    VOY_Database_var databaseRef_;
    StreamMap streamMap_;
    Play_Stream_Synchronizer * synch_;
    VOY_String payFreqFileName_;
};

#endif

