#ifndef _Play_Stream_Synchronizer_h_
#define _Play_Stream_Synchronizer_h_

#include "list.h"
#include "ace/OS.h"
#include "Play_Session_ID.h"

/////////////////////////////////////////////////////////////////////////////
//
// Play_Stream_Synchronizer.h
//
// Revision History
//     17 Sep 97 - lisa - original version
//

class Stream_Source;
class RTSP_Play_Request;

class Play_Stream_Synchronizer
{
public:
    Play_Stream_Synchronizer(  Play_Session_ID );

    void registerStream( Stream_Source* , ACE_Time_Value );
    void unregisterStream( Stream_Source* );
    void play( RTSP_Play_Request* );

private:
    ~Play_Stream_Synchronizer(  );  // private destructor so it can only be created on the heap
    
    list< Stream_Source* > sourceList_;
    ACE_Time_Value           minTime_;
    short                                    minTimeNotSet_;
    Play_Session_ID            sessionId_;
};

#endif

