#include <ace/Reactor.h>
#include "RTCP_Listener.h"

RTCP_Listener::RTCP_Listener(ACE_SOCK_Dgram* sock , RTCP_Packet_Sink *sink ,
			     ACE_Reactor* reactor ) : Packet_Handler( sock ) ,
                                                             packetSink_( sink ) , reactor_( reactor )
{
    assert( sock && sink && reactor );

    //reactor_->register_handler( sock->get_handle( ) , this , ACE_Event_Handler::READ_MASK );
    reactor_->register_handler( this , ACE_Event_Handler::READ_MASK );
}

RTCP_Listener::~RTCP_Listener(void)
{
    int rc = reactor_->remove_handler( this ,  (ACE_Event_Handler::READ_MASK | ACE_Event_Handler::DONT_CALL) );
    printf( "RTCP_Listener::~RTCP_Listener: removing handler %x, rc=%d\n" , this , rc );
}

int
RTCP_Listener::handlePacket( char* buffer , int size , ACE_INET_Addr& from )
{
    char* p;
    RTCP_Packet::RTCP_Header* hdr;

    p = buffer;
    hdr = ( RTCP_Packet::RTCP_Header* )p;
    packetSink_->handlePacket( hdr , buffer , size , from , socket_ );

    while( p < ( buffer + size ) )
    {
	hdr = ( RTCP_Packet::RTCP_Header * )p;
	int len  = hdr->get_length( );

	if( packetSink_ )
	    packetSink_->handleSubpacket( hdr , p , 4 * (len + 1) , from , socket_ );
	    
	p += 4 * (hdr->get_length() + 1);
    }
    return 0;
}

char*
RTCP_Listener::getBuffer( int* size )
{
    return packetBuffer_.get_buffer( size );
}
