#include <ace/Reactor.h>
#include "RTP_Listener.h"


RTP_Listener::RTP_Listener( ACE_SOCK_Dgram* sock , RTP_Packet_Sink* sink ,
			    ACE_Reactor* reactor ) : Packet_Handler( sock ) ,
                                                            packetSink_( sink ) , reactor_( reactor )
{
    assert( sock && sink && reactor );

    // reactor_->register_handler( sock->get_handle( ) , this , ACE_Event_Handler::READ_MASK );
    reactor_->register_handler( this , ACE_Event_Handler::READ_MASK );
}

RTP_Listener::~RTP_Listener( void )
{
   int rc = reactor_->remove_handler( this , (ACE_Event_Handler::READ_MASK | ACE_Event_Handler::DONT_CALL) );
   printf( "RTP_Listener::~RTP_Listener: listener %x, rc from remove_handler %d\n" , this , rc );
}

int
RTP_Listener::handlePacket( char* buffer , int size ,  ACE_INET_Addr& from )
{
    RTP_Packet::RTP_Header* hdr = &( packetBuffer_.u.header_  );

    if( packetSink_  )
	packetSink_->handlePacket( hdr , buffer , size , from , socket_  );

    return 0;
}

char*
RTP_Listener::getBuffer( int* size )
{
    return packetBuffer_.get_buffer( size );
}
