#ifndef _RTP_Packet_Sink_h
#define _RTP_Packet_Sink_h

/*
 * Mixin class for objects that can sink an RTP packet stream.
 */

#include "RTP_Packet.h"
#include "ace/INET_Addr.h"
#include "ace/SOCK_Dgram.h"

class ACE_SOCK_Dgram;

class RTP_Packet_Sink
{
public:
    virtual void handlePacket(RTP_Packet::RTP_Header *packet_header,
			       char *packet_data, int packet_data_size,
			       ACE_INET_Addr &packet_source,
			       ACE_SOCK_Dgram *sock = 0) = 0;
			       
};

#endif /* _RTP_Packet_Sink_h */
