#ifndef _RTSP_Request_h
#define _RTSP_Request_h

class RTSP_Request_Packet;

#include <stream.h>
#include "Voyager_Session_ID.h"

class Dispatcher;

class RTSP_Request
{
public:
    RTSP_Request();

    ~RTSP_Request( );

    static RTSP_Request *createRequest(RTSP_Request_Packet *);

    int setRequest( RTSP_Request_Packet *r );

    RTSP_Request_Packet *requestPacket() { return requestPacket_; }

    virtual void dispatch(Dispatcher *) = 0;

    virtual ostream& put(ostream &) const;

    Voyager_Session_ID sessionId( void ) {return sessionId_; }
    void streamId(char *streamId ) const;
    
protected:
 
    virtual int setRequestPacket(RTSP_Request_Packet* r) = 0;

    RTSP_Request_Packet *requestPacket_;
    Voyager_Session_ID sessionId_;
    char *streamId_;
};

inline ostream& operator<<(ostream &os, RTSP_Request &r)
{
    return r.put(os);
}

#endif /* _RTSP_Request_h */
