#ifndef _RTSP_Response_h
#define _RTSP_Response_h

#include "config.h"
#include <ace/SOCK_Stream.h>
#include <ace/Synch.h>

#include <map.h>

class RTSP_Engine;

class RTSP_Response
{
public:
    RTSP_Response(int code, char *reason, int sequence = -1);
    RTSP_Response(int code, char *reason, const char *sequence);

    int code() { return code_; }
    char *reason() { return reason_; }
    char *version() { return version_; }
    int sequence() { return sequence_; }
    
    void send(RTSP_Engine *);

    typedef map<VOY_String, VOY_String, less<VOY_String> > Header_Map;

    void setHeader(char *hdr, char *value);
    void bodyInit(int size);
    void bodyAppendf(const char *fmt, ...);
    void bodyAppend(const char *fmt);
    void bodyDone();
    
protected:
    Header_Map headerMap_;
    char *version_;
    int code_;
    int sequence_;
    char *reason_;
    char *body_;
};

#endif
