#ifndef _Record_Listener_h_
#define _Record_Listener_h_

/////////////////////////////////////////////////////////////////////////////
//
// Record_Listener.h
//
// Revision History
//     09 Jan 98 - lisa - adapted from prototype recording code
//


#include "config.h"

class Record_Session_Manager;
class Record_Network_Transport;
class ACE_Reactor;
class RTSP_Record_Request;
class RTP_Listener;
class RTCP_Listener;
class Record_Archive_Manager;
class Transport_Manager;

class Record_Listener
{
public:
    Record_Listener( Record_Session_Manager* , Record_Network_Transport* ,
		     Record_Archive_Manager* , ACE_Reactor* );
    ~Record_Listener( );

    void record( RTSP_Record_Request* );

    void teardown( Transport_Manager* );

private:

    ACE_Reactor* reactor_;
    Record_Archive_Manager* archiveMgr_;
    Record_Network_Transport* netTrans_;
    Record_Session_Manager* recordMgr_;
    RTP_Listener*  rtpListener_;
    RTCP_Listener*  rtcpListener_;
};

#endif
