#ifndef _Record_Session_Manager_h_
#define _Record_Session_Manager_h_

#include "config.h"
#include "map.h"

class RTSP_Setup_Request;
class RTSP_Record_Request;
class Record_Network_Transport;
class Record_Listener;
class Record_Archive_Manager;
class RTSP_Teardown_Request;
class Transport_Manager;

#include "Record_Session_ID.h"
#include "Voyager_Corba.h"

class Record_Session_Manager
{
public:
    Record_Session_Manager( VOY_Database_ptr, Record_Session_ID, RTSP_Setup_Request* );
    ~Record_Session_Manager(  );

    enum RecordSessionError { kFailure , kSuccess };
    
    RecordSessionError   addSender( RTSP_Setup_Request* , Record_Network_Transport*);
    RecordSessionError   record( RTSP_Record_Request* );

    void teardown( RTSP_Teardown_Request* , Transport_Manager* , short& qNoMoreStreams );

    Record_Session_ID sessionId() { return sessionId_; }

private:

    typedef map< VOY_String , Record_Listener* , less<VOY_String> > ListenMap;
    
    Record_Session_ID sessionId_;
    int  dbSessionId_;
    VOY_Database_var databaseRef_;
    ListenMap listenMap_;
    Record_Archive_Manager* archiveMgr_;
};

#endif

