#ifndef _Session_Manager_h
#define _Session_Manager_h

#include <ace/OS.h>
#include <ace/Map_Manager.h>
#include <ace/Synch.h>
#include <ace/Singleton.h>
#include "Voyager_Session.h"
#include "Voyager_Defs.h"
#include "Play_Session_ID.h"
#include "Play_Session_Manager.h"
#include "Voyager_Corba.h"

class RTSP_Request_Packet;
class RTSP_Describe_Request;
class RTSP_Setup_Request;
class Transport_Manager;

//class Voyager_DB;

/**
 * Session manager keeps track of all the sessions in this server instance.
 * For now, there'll just be the one.
 *
 **/

class Session_Manager
{
public:
    Session_Manager();
    Session_Manager(VOY_Database_var db);

   ~ Session_Manager( );

//    void setVoyagerDB(Voyager_DB *db) { voyagerDB_ = db; }

    void addSession(Voyager_Session *);

    void handleRequest(RTSP_Request_Packet *);

    void handleDescribe(RTSP_Describe_Request *);

//    void handleSetup(RTSP_Setup_Request *);

    void handleError(RTSP_Request_Packet *);

protected:
//    Voyager_DB *voyagerDB_;
    VOY_Database_var db_;

    typedef ACE_Map_Manager<Voyager_Session_ID, Voyager_Session *,
	VOYAGER_MUTEX>
    	Voyager_Session_Map;

    typedef ACE_Map_Manager<Play_Session_ID, Play_Session_Manager*,
                  	VOYAGER_MUTEX> Play_Session_Map;
  
    Voyager_Session *findVoyagerSession(Voyager_Session_ID);
    Voyager_Session_Map voyagerSessionMap_;

    Play_Session_Manager* findOrCreatePlaySession( Play_Session_ID );
    Play_Session_Map playSessionMap_;

    Transport_Manager* transMan_;

private:
};

#endif
