#ifndef _Transport_Manager_h_
#define _Transport_Manager_h_

#include "config.h"

#include <map.h>

#include "Network_Endpoint.h"

class RTSP_Setup_Request;
class Record_Network_Transport;
class Playback_Network_Transport;

/////////////////////////////////////////////////////////////////////////////
//
// Transport_Manager.h
//
// Revision History
//     17 Sep 97 - lisa - original version
//      27 jan 98 - lisa - adding support for record
//

class Transport_Manager
{
public:
    Transport_Manager(  );
    ~Transport_Manager(  );

    void closeTransport( Record_Network_Transport* );

    Record_Network_Transport* setupRecordTransport( RTSP_Setup_Request* );
    Playback_Network_Transport* setupPlaybackTransport( RTSP_Setup_Request* );

    typedef map<VOY_String , Record_Network_Transport* , less<VOY_String> > RecHostMap;
    typedef map< int, RecHostMap* , less<int> > RecPortHostMap;
    typedef map<VOY_String , Playback_Network_Transport* , less<VOY_String> > PlayHostMap;
    typedef map< int, PlayHostMap* , less<int> > PlayPortHostMap;

private:
    void computeEndpoint( RTSP_Setup_Request* , Network_Endpoint& );

    short currentRecHostPort( Network_Endpoint& );
    void storeRecHostPort( Network_Endpoint& , Record_Network_Transport* );
    void storePlayHostPort( Network_Endpoint& , Playback_Network_Transport* );
    short currentPlayHostPort( Network_Endpoint& );
    Playback_Network_Transport* getPlayTransport( Network_Endpoint& );
    Record_Network_Transport* getRecTransport( Network_Endpoint& );
    short currentRecPort( int );
    short currentPlayPort( int );
    void removeRecHostPort( Network_Endpoint& );

    RecPortHostMap recPortHostMap_;
    PlayPortHostMap playPortHostMap_;
};

#endif

