#ifndef _Voyager_Session_h
#define _Voyager_Session_h

class RTSP_Describe_Request;
//class Voyager_DB;

#include "config.h"
#include "Voyager_Stream.h"
#include "Voyager_Session_ID.h"
#include "Voyager_Corba.h"

#include <ace/OS.h>

#include <map.h>

class Voyager_Session
{
public:
    Voyager_Session(Voyager_Session_ID id);

//    static Voyager_Session *loadFromDB(Voyager_Session_ID id,
//				       Voyager_DB *db);

    static Voyager_Session *loadFromDB(Voyager_Session_ID id,
					     VOY_Database_var db);
    void addStream(Voyager_Stream *);

    void handleDescribeSession(RTSP_Describe_Request *);
    void handleDescribeStream(RTSP_Describe_Request *, char *ssrc);

    Voyager_Session_ID id() { return id_; }

    void setName(char *name) { name_ = name; }
    void setDescription(char *desc) { description_ = desc; }

    char *name() { return name_; }
    char *description() { return description_; }

    typedef map<VOY_String, Voyager_Stream *, less<VOY_String> > Stream_Map;

protected:
    Voyager_Session_ID id_;

    Stream_Map streamMap_;

    char *name_;
    char *description_;
};

#endif
