#ifndef _Voyager_Stream_h
#define _Voyager_Stream_h

class RTSP_Describe_Request;
//class Voyager_DB;

#include "config.h"
#include "Voyager_Session_ID.h"
#include "Voyager_Corba.h"

#include <map.h>

class Voyager_Stream
{
public:
    Voyager_Stream(Voyager_Session_ID id, char *ssrc);

//    void loadFromDB(Voyager_DB *db);
    void loadFromDB(VOY_Database_var db);

    Voyager_Session_ID sessionId() { return sessionId_; }
    char *ssrc() { return ssrc_; }

    void setParameter(char *name, char *value);

    void handleDescribeStream(RTSP_Describe_Request *);

    double startTime() { return startTime_; }
    double startingTimestamp() { return startingTimestamp_; }
    double synchNTPTimestamp() { return synchNTPTimestamp_; }
    int synchRTPTimestamp() { return synchRTPTimestamp_; }
    char *packetTypes() { return packetTypes_; }
    double duration() { return duration_; }
    int packetsSeen() { return packetsSeen_; }
    int packetsMissed() { return packetsMissed_; }
    int bytes() { return bytes_; }

    enum ParameterType { INT, DOUBLE, STRING };

    typedef map<VOY_String, VOY_String, less<VOY_String> > MAP;

protected:

    struct Parameter
    {
	char *name;
	ParameterType type;
	int Voyager_Stream::* iptr;
	double Voyager_Stream::* dptr;
	char * Voyager_Stream::* sptr;
    };

    static Parameter parameters_[];

    MAP parameterMap_;

    Voyager_Session_ID sessionId_;
    char *ssrc_;

    double startTime_;
    double startingTimestamp_;
    double synchNTPTimestamp_;
    int synchRTPTimestamp_;
    char *packetTypes_;
    double duration_;
    int packetsSeen_;
    int packetsMissed_;
    int bytes_;
};

#endif
